Index: code/branches/console/src/core/TclThreadManager.cc
===================================================================
--- code/branches/console/src/core/TclThreadManager.cc	(revision 1334)
+++ code/branches/console/src/core/TclThreadManager.cc	(revision 1337)
@@ -67,5 +67,9 @@
         this->orxonoxInterpreterBundle_.id_ = 0;
         this->orxonoxInterpreterBundle_.interpreter_ = TclBind::getInstance().getTclInterpreter();
+#if (BOOST_VERSION >= 103500)
         this->threadID_ = boost::this_thread::get_id();
+#else
+        //
+#endif
     }
 
@@ -119,5 +123,9 @@
                     {
                         boost::mutex::scoped_lock bundles_lock(TclThreadManager::getInstance().bundlesMutex_);
-                        boost::mutex::scoped_lock interpreter_lock(bundle->interpreterMutex_, boost::defer_lock_t());
+#if (BOOST_VERSION >= 103500)
+                        boost::mutex::scoped_try_lock interpreter_lock(bundle->interpreterMutex_);
+#else
+                        boost::try_mutex::scoped_try_lock interpreter_lock(bundle->interpreterMutex_);
+#endif
                         try
                         {
@@ -125,5 +133,9 @@
                             {
                                 TclThreadManager::getInstance().orxonoxEvalCondition_.notify_one();
+#if (BOOST_VERSION >= 103500)
                                 boost::this_thread::yield();
+#else
+                                boost::thread::yield();
+#endif
                             }
                         } catch (...) {}
@@ -136,5 +148,9 @@
 
                 TclThreadManager::getInstance().orxonoxEvalCondition_.notify_one();
+#if (BOOST_VERSION >= 103500)
                 boost::this_thread::yield();
+#else
+                boost::thread::yield();
+#endif
             }
 
@@ -183,5 +199,9 @@
             output += "\t\t";
             {
-                boost::mutex::scoped_lock interpreter_lock((*it).second->interpreterMutex_, boost::defer_lock_t());
+#if (BOOST_VERSION >= 103500)
+                boost::mutex::scoped_try_lock interpreter_lock((*it).second->interpreterMutex_);
+#else
+                boost::try_mutex::scoped_try_lock interpreter_lock((*it).second->interpreterMutex_);
+#endif
                 if (interpreter_lock.try_lock())
                     output += "ready";
@@ -332,10 +352,18 @@
     void TclThreadManager::error(const std::string& error)
     {
+#if (BOOST_VERSION >= 103500)
         if (boost::this_thread::get_id() != this->threadID_)
+#else
+        if (boost::thread() != this->threadID_)
+#endif
         {
             boost::mutex::scoped_lock queue_lock(this->orxonoxInterpreterBundle_.queueMutex_);
             if (this->orxonoxInterpreterBundle_.queue_.size() >= TCLTHREADMANAGER_MAX_QUEUE_LENGTH)
             {
+#if (BOOST_VERSION >= 103500)
                 boost::this_thread::yield();
+#else
+                boost::thread::yield();
+#endif
                 return;
             }
@@ -347,10 +375,18 @@
     void TclThreadManager::debug(const std::string& error)
     {
+#if (BOOST_VERSION >= 103500)
         if (boost::this_thread::get_id() != this->threadID_)
+#else
+        if (boost::thread() != this->threadID_)
+#endif
         {
             boost::mutex::scoped_lock queue_lock(this->orxonoxInterpreterBundle_.queueMutex_);
             if (this->orxonoxInterpreterBundle_.queue_.size() >= TCLTHREADMANAGER_MAX_QUEUE_LENGTH)
             {
+#if (BOOST_VERSION >= 103500)
                 boost::this_thread::yield();
+#else
+                boost::thread::yield();
+#endif
                 return;
             }
@@ -461,5 +497,9 @@
             if (this->updateQueriersList(querier, &this->orxonoxInterpreterBundle_))
             {
+#if (BOOST_VERSION >= 103500)
                 boost::mutex::scoped_lock interpreter_lock(this->orxonoxInterpreterBundle_.interpreterMutex_);
+#else
+                boost::try_mutex::scoped_lock interpreter_lock(this->orxonoxInterpreterBundle_.interpreterMutex_);
+#endif
                 this->orxonoxEvalCondition_.wait(interpreter_lock);
 
@@ -498,5 +538,9 @@
                 if (this->updateQueriersList(querier, target))
                 {
-                    boost::mutex::scoped_lock interpreter_lock(target->interpreterMutex_, boost::defer_lock_t());
+#if (BOOST_VERSION >= 103500)
+                    boost::mutex::scoped_try_lock interpreter_lock(target->interpreterMutex_);
+#else
+                    boost::try_mutex::scoped_try_lock interpreter_lock(target->interpreterMutex_);
+#endif
                     bool successfullyLocked = false;
                     try
@@ -507,5 +551,11 @@
                         {
                             while (!interpreter_lock.try_lock())
+                            {
+#if (BOOST_VERSION >= 103500)
                                 boost::this_thread::yield();
+#else
+                                boost::thread::yield();
+#endif
+                            }
 
                             successfullyLocked = true;
@@ -540,5 +590,9 @@
         {
             this->orxonoxEvalCondition_.notify_one();
+#if (BOOST_VERSION >= 103500)
             boost::this_thread::yield();
+#else
+            boost::thread::yield();
+#endif
         }
 
@@ -562,5 +616,9 @@
 
         {
+#if (BOOST_VERSION >= 103500)
             boost::mutex::scoped_lock interpreter_lock(this->orxonoxInterpreterBundle_.interpreterMutex_);
+#else
+            boost::try_mutex::scoped_lock interpreter_lock(this->orxonoxInterpreterBundle_.interpreterMutex_);
+#endif
             unsigned long maxtime = (unsigned long)(dt * 1000000 * TCLTHREADMANAGER_MAX_CPU_USAGE);
             Ogre::Timer timer;
@@ -577,5 +635,9 @@
     {
         TclThreadManager::getInstance().debug("TclThread_execute: " + command);
+#if (BOOST_VERSION >= 103500)
         boost::mutex::scoped_lock interpreter_lock(interpreterBundle->interpreterMutex_);
+#else
+        boost::try_mutex::scoped_lock interpreter_lock(interpreterBundle->interpreterMutex_);
+#endif
         try
         {
Index: code/branches/console/src/core/TclThreadManager.h
===================================================================
--- code/branches/console/src/core/TclThreadManager.h	(revision 1334)
+++ code/branches/console/src/core/TclThreadManager.h	(revision 1337)
@@ -36,4 +36,5 @@
 #include <boost/thread/mutex.hpp>
 #include <boost/thread/condition.hpp>
+#include <boost/thread/thread.hpp>
 
 #include "CorePrereqs.h"
@@ -119,5 +120,9 @@
             boost::condition fullQueueCondition_;
             boost::condition orxonoxEvalCondition_;
+#if (BOOST_VERSION >= 103500)
             boost::thread::id threadID_;
+#else
+            boost::thread threadID_;
+#endif
     };
 