Index: code/branches/hud3/bin/levels/sample.oxw
===================================================================
--- code/branches/hud3/bin/levels/sample.oxw	(revision 1354)
+++ code/branches/hud3/bin/levels/sample.oxw	(revision 1356)
@@ -14,5 +14,5 @@
 <Skybox src="Orxonox/StarSkyBox" />
 <SpaceShip camera="true" position="0,0,0" scale="10" yawpitchroll="0,0,0" mesh="assff.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
-<Model position="1500,0,0" scale="10" mesh="tomato.mesh" yawpitchroll="-40,30,0" rotationAxis="1,0,0" rotationRate="-30"/>
+<Model position="1500,0,100" scale="10" mesh="tomato.mesh" yawpitchroll="-40,30,0" rotationAxis="1,0,0" rotationRate="-30"/>
 <Model position="0,4200,0" scale="10" mesh="tomato.mesh" yawpitchroll="-50,60,0" rotationAxis="1,0,0" rotationRate="-30"/>
 <Model position="0,0,6800" scale="10" mesh="tomato.mesh" yawpitchroll="-50,-30,0" rotationAxis="1,0,0" rotationRate="-30"/>
Index: code/branches/hud3/src/orxonox/hud/HUD.cc
===================================================================
--- code/branches/hud3/src/orxonox/hud/HUD.cc	(revision 1354)
+++ code/branches/hud3/src/orxonox/hud/HUD.cc	(revision 1356)
@@ -33,4 +33,5 @@
 #include <OgreSceneNode.h>
 #include <OgreEntity.h>
+#include <OgreStringConverter.h>
 #include "core/Debug.h"
 #include "objects/SpaceShip.h"
@@ -55,4 +56,13 @@
         orxonoxHUD = om->create("Orxonox/HUD");
         container = static_cast<Ogre::OverlayContainer*>(om->createOverlayElement("Panel", "Orxonox/HUD/container"));
+        // test
+        test = static_cast<TextAreaOverlayElement*>(om->createOverlayElement("TextArea", "test123"));
+        test->show();
+        test->setMetricsMode(Ogre::GMM_RELATIVE);
+        test->setDimensions(0.8, 0.8);
+        test->setPosition(0.02, 0.02);
+        test->setFontName("Console");
+        test->setCaption("init");
+
         // create energy bar
         energyBar = static_cast<BarOverlayElement*>(om->createOverlayElement("Bar", "energyBar"));
@@ -75,11 +85,12 @@
         container->setHeight(1.0);
         container->setMetricsMode(Ogre::GMM_RELATIVE);
+        container->addChild(test);
         energyBar->init(0.01, 0.94, 0.4, container);
         energyBar->setValue(1);
         speedoBar->init(0.01, 0.90, 0.4, container);
         radar->init(0.5, 0.9, 0.2, container);
-        radar->addObject(Vector3(1500.0, 0.0, 0.0));
+        radar->addObject(Vector3(1500.0, 0.0, 100.0));
         radar->addObject(Vector3(0.0, 4000.0, 0.0));
-	radar->addObject(Vector3(0.0, 0.0, 6800.0));
+        radar->addObject(Vector3(0.0, 0.0, 6800.0));
         RadarOverlayElement::cycleFocus();
     }
@@ -87,4 +98,7 @@
     void HUD::tick(float dt)
     {
+        int d = radar->getDist2Focus()/10;
+        test->setCaption("Distance: " + Ogre::StringConverter::toString(d));
+
         energyBar->resize();
 
Index: code/branches/hud3/src/orxonox/hud/HUD.h
===================================================================
--- code/branches/hud3/src/orxonox/hud/HUD.h	(revision 1354)
+++ code/branches/hud3/src/orxonox/hud/HUD.h	(revision 1356)
@@ -32,4 +32,5 @@
 #include <string.h>
 #include <OgreOverlayElement.h>
+#include <OgreTextAreaOverlayElement.h>
 #include <OgrePrerequisites.h>
 
@@ -48,4 +49,5 @@
             Ogre::Overlay* orxonoxHUD;
             Ogre::OverlayContainer* container;
+            Ogre::TextAreaOverlayElement* test;
             BarOverlayElement* energyBar;
             BarOverlayElement* speedoBar;
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1354)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1356)
@@ -181,4 +181,8 @@
 	}
 
+	float RadarOverlayElement::getDist2Focus(){
+	    return((focus_->pos_-shipPos_).length());
+	}
+
 	float RadarOverlayElement::calcRadius(RadarObject* obj){
 	    return(acos((currentDir_.dotProduct(obj->pos_ - shipPos_))/
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1354)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1356)
@@ -72,4 +72,5 @@
             void addObject(Vector3 pos);
             void listObjects();
+            float getDist2Focus();
             float calcRadius(RadarObject* obj);
             float calcPhi(RadarObject* obj);