Index: code/branches/merge/src/network/ClientInformation.cc
===================================================================
--- code/branches/merge/src/network/ClientInformation.cc	(revision 1360)
+++ code/branches/merge/src/network/ClientInformation.cc	(revision 1361)
@@ -51,5 +51,4 @@
     preve=0;
     nexte=0;
-    partialGamestateID_=GAMESTATEID_INITIAL-1;
     this->head_=false;
     synched_=false;
@@ -60,5 +59,4 @@
     preve=0;
     nexte=0;
-    partialGamestateID_=GAMESTATEID_INITIAL-1;
     this->head_=head;
     synched_=false;
@@ -161,12 +159,4 @@
     return true;
   }
-  
-  bool ClientInformation::setPartialGamestateID(int id){
-    boost::recursive_mutex::scoped_lock lock(mutex_);
-    if(!this)
-      return false;
-    partialGamestateID_=id;
-    return true;
-  }
 
   int ClientInformation::getID() {
@@ -213,12 +203,4 @@
     if(this)
       return gamestateID_;
-    else
-      return -1;
-  }
-  
-  int ClientInformation::getPartialGamestateID() {
-    boost::recursive_mutex::scoped_lock lock(mutex_);
-    if(this)
-      return partialGamestateID_;
     else
       return -1;
Index: code/branches/merge/src/network/ClientInformation.h
===================================================================
--- code/branches/merge/src/network/ClientInformation.h	(revision 1360)
+++ code/branches/merge/src/network/ClientInformation.h	(revision 1361)
@@ -70,5 +70,4 @@
     bool setPeer(ENetPeer *peer);
     bool setGamestateID(int id);
-    bool setPartialGamestateID(int id);
     inline void setShipID(int id){ShipID_=id;}
     
@@ -77,5 +76,4 @@
     int getID();
     int getGamestateID();
-    int getPartialGamestateID();
     ENetPeer *getPeer();
     bool getHead();
@@ -109,5 +107,4 @@
     int clientID_;
     int gamestateID_;
-    int partialGamestateID_;
     int ShipID_;   // this is the unique objectID
     bool synched_;
Index: code/branches/merge/src/network/ConnectionManager.cc
===================================================================
--- code/branches/merge/src/network/ConnectionManager.cc	(revision 1360)
+++ code/branches/merge/src/network/ConnectionManager.cc	(revision 1361)
@@ -193,4 +193,6 @@
           addClient(event);
           //this is a workaround to ensure thread safety
+          /*if(!addFakeConnectRequest(&event))
+            COUT(3) << "Problem pushing fakeconnectRequest to queue" << std::endl;*/
           COUT(5) << "Con.Man: connection event has occured" << std::endl;
           break;
@@ -208,5 +210,4 @@
           break;
         case ENET_EVENT_TYPE_NONE:
-          receiverThread_->yield();
           break;
       }
Index: code/branches/merge/src/network/GameStateClient.cc
===================================================================
--- code/branches/merge/src/network/GameStateClient.cc	(revision 1360)
+++ code/branches/merge/src/network/GameStateClient.cc	(revision 1361)
@@ -47,5 +47,4 @@
     COUT(5) << "this: " << this << std::endl;
     last_diff_=0;
-    last_gamestate_=GAMESTATEID_INITIAL-1;
   }
 
@@ -57,9 +56,4 @@
     printGameStateMap();
     GameState *gs, *reference;
-    /*if(compstate->id<last_gamestate_){
-      // network packets got messed up
-      COUT(3) << "received an obsolete gamestate" << std::endl;
-      return false;
-    }*/
     if(compstate->diffed && compstate->base_id!=GAMESTATEID_INITIAL){
       std::map<int, GameState*>::iterator it = gameStateMap.find(compstate->base_id);
@@ -83,5 +77,4 @@
         COUT(4) << "adding decoded gs with id: " << gs->id << " diffed from: " << gs->base_id << std::endl;
         last_diff_=gs->base_id;
-        //last_gamestate_=gs->id;
         return true;
       }else{
@@ -156,8 +149,4 @@
           Synchronisable *no = dynamic_cast<Synchronisable *>(id->fabricate());
           COUT(4) << "loadsnapshot: classid: " << sync.classID << " objectID: " << sync.objectID << " length: " << sync.length << std::endl;
-          if(!no){
-            COUT(2) << "coudl not frabricate classid: " << sync.classID << " objectID: " << sync.objectID << " identifier: " << id << std::endl;
-            break;
-          }
           no->objectID=sync.objectID;
           no->classID=sync.classID;
Index: code/branches/merge/src/network/GameStateClient.h
===================================================================
--- code/branches/merge/src/network/GameStateClient.h	(revision 1360)
+++ code/branches/merge/src/network/GameStateClient.h	(revision 1361)
@@ -71,5 +71,4 @@
 
     int           last_diff_;
-    int           last_gamestate_;
     std::map<int, GameState *> gameStateMap;
     
Index: code/branches/merge/src/network/GameStateManager.cc
===================================================================
--- code/branches/merge/src/network/GameStateManager.cc	(revision 1360)
+++ code/branches/merge/src/network/GameStateManager.cc	(revision 1361)
@@ -221,12 +221,4 @@
     orxonox::Iterator<Synchronisable> it=orxonox::ObjectList<Synchronisable>::start();
     syncData sync;
-    /*ClientInformation *client = head_->findClient(clientID);
-    if(client)
-      if(client->getPartialGamestateID()>state->id){
-        COUT(3) << "we received an obsolete partial gamestate" << std::endl;
-        return false;
-      }
-    else;*/
-        //what should we do now ??
     // loop as long as we have some data ;)
     while(data < state->data+state->size){
@@ -276,5 +268,5 @@
       ++it;
     }
-    //client->setPartialGamestateID(state->id);
+    
     return true;
   }
@@ -436,7 +428,4 @@
       return;
     int curid = temp->getGamestateID();
-    if(curid > gamestateID)
-      // the network packets got messed up 
-      return;
     COUT(4) << "acking gamestate " << gamestateID << " for clientid: " << clientID << " curid: " << curid << std::endl;
     // decrease usage of gamestate and save it
Index: code/branches/merge/src/network/PacketManager.h
===================================================================
--- code/branches/merge/src/network/PacketManager.h	(revision 1360)
+++ code/branches/merge/src/network/PacketManager.h	(revision 1361)
@@ -58,10 +58,12 @@
     PacketGenerator();
     //call one of this functions out of an instance of PacketGenerator to create a packet
-    ENetPacket* acknowledgement( int state, int reliable = 0 ); // we do not want reliability
+//    ENetPacket* acknowledgement( int state, int reliable = 0 );
+    ENetPacket* acknowledgement( int state, int reliable = ENET_PACKET_FLAG_RELIABLE );
     ENetPacket* command( int dataLength, void *data, int reliable = ENET_PACKET_FLAG_RELIABLE );
     ENetPacket* mousem( double x, double y, int reliable = ENET_PACKET_FLAG_RELIABLE );
     ENetPacket* keystrike( char press, int reliable = ENET_PACKET_FLAG_RELIABLE );
     ENetPacket* chatMessage( const char* message, int reliable = ENET_PACKET_FLAG_RELIABLE );
-    ENetPacket* gstate( GameStateCompressed *states, int reliable = 0 ); // we do not want reliability of gamestates
+    ENetPacket* gstate( GameStateCompressed *states, int reliable = ENET_PACKET_FLAG_RELIABLE );
+//    ENetPacket* gstate( GameStateCompressed *states, int reliable = 0 );
     ENetPacket* clid( int classid, std::string classname, int reliable = ENET_PACKET_FLAG_RELIABLE );
     ENetPacket* generateWelcome( int clientID,int shipID, bool allowed, int reliable = ENET_PACKET_FLAG_RELIABLE );
Index: code/branches/merge/src/network/Synchronisable.cc
===================================================================
--- code/branches/merge/src/network/Synchronisable.cc	(revision 1360)
+++ code/branches/merge/src/network/Synchronisable.cc	(revision 1361)
@@ -156,5 +156,5 @@
     if(classID==0)
       COUT(3) << "classid 0 " << this->getIdentifier()->getName() << std::endl;
-    this->classID=this->getIdentifier()->getNetworkID();
+    classID=this->getIdentifier()->getNetworkID();
     std::list<synchronisableVariable *>::iterator i;
     syncData retVal;
Index: code/branches/merge/src/orxonox/objects/WorldEntity.cc
===================================================================
--- code/branches/merge/src/orxonox/objects/WorldEntity.cc	(revision 1360)
+++ code/branches/merge/src/orxonox/objects/WorldEntity.cc	(revision 1361)
@@ -156,5 +156,5 @@
       registerVar( (void*) &(this->getAcceleration().y), sizeof(this->getAcceleration().y), network::DATA, 0x3);
       registerVar( (void*) &(this->getAcceleration().z), sizeof(this->getAcceleration().z), network::DATA, 0x3);
-      registerVar( (void*) &(this->getMomentum()), sizeof(this->getMomentum()), network::DATA);
+      registerVar( (void*) &(this->getMomentum()), sizeof(this->getMomentum()), network::DATA, 0x3);
     }
 