Index: /code/branches/network/src/network/Client.cc
===================================================================
--- /code/branches/network/src/network/Client.cc	(revision 1376)
+++ /code/branches/network/src/network/Client.cc	(revision 1377)
@@ -122,7 +122,7 @@
       COUT(3) << "sending connectrequest" << std::endl;
       if(!client_connection.addPacket(pck_gen.generateConnectRequest()) || !client_connection.sendPackets())
-        COUT(1) << "could not create connection" << std::endl;
+        COUT(1) << "could not send connection request !!!!!!!!!" << std::endl;
     }else
-      COUT(1) << "could not create connection" << std::endl;
+      COUT(1) << "could not create connection laber" << std::endl;
     return isConnected;
   }
@@ -216,11 +216,7 @@
     if(!isConnected)
       return false;
-    ENetEvent event;
-    // send packets
-    client_connection.sendPackets(&event);
-    if(event.type==ENET_EVENT_TYPE_NONE)
-      return true;
-    else
-      return false;
+    // send packets
+    client_connection.sendPackets();
+    return true;
   }
 
Index: /code/branches/network/src/network/ClientConnection.cc
===================================================================
--- /code/branches/network/src/network/ClientConnection.cc	(revision 1376)
+++ /code/branches/network/src/network/ClientConnection.cc	(revision 1377)
@@ -98,5 +98,5 @@
     //network_threads.create_thread(boost::bind(boost::mem_fn(&ClientConnection::receiverThread), this));
     // wait 10 seconds for the connection to be established
-    return waitEstablished(10000);
+    return waitEstablished(3000);
   }
 
@@ -123,21 +123,19 @@
   }
 
-  bool ClientConnection::sendPackets(ENetEvent *event) {
+//   bool ClientConnection::sendPackets(ENetEvent *event) {
+//     if(server==NULL)
+//       return false;
+//     if(enet_host_service(client, event, NETWORK_SEND_WAIT)>=0){
+//       return true;}
+//     else
+//       return false;
+//   }
+
+  bool ClientConnection::sendPackets() {
+    ENetEvent event;
     if(server==NULL)
       return false;
-    if(enet_host_service(client, event, NETWORK_SEND_WAIT)>=0){
-      return true;}
-    else
-      return false;
-  }
-
-  bool ClientConnection::sendPackets() {
-    ENetEvent event;
-    if(server==NULL)
-      return false;
-    if(enet_host_service(client, &event, NETWORK_SEND_WAIT)>=0){
-      return true;}
-    else
-      return false;
+    enet_host_flush(client);
+    return true;
   }
 
@@ -148,9 +146,12 @@
     ENetEvent event;
     client = enet_host_create(NULL, NETWORK_CLIENT_MAX_CONNECTIONS, 0, 0);
-    if(client==NULL)
+    if(client==NULL) {
+      COUT(2) << "ClientConnection: could not create client host" << std::endl;
       // add some error handling here ==========================
       quit=true;
+    }
     //connect to the server
     if(!establishConnection()){
+      COUT(2) << "clientConn: receiver thread: could not establishConnection" << std::endl;
       quit=true;
       return;
@@ -167,4 +168,5 @@
         // log handling ================
       case ENET_EVENT_TYPE_CONNECT:
+        break;
       case ENET_EVENT_TYPE_RECEIVE:
         COUT(5) << "Cl.Con: receiver-Thread while loop: got new packet" << std::endl;
@@ -213,14 +215,18 @@
     // connect to peer (server is type ENetPeer*)
     server = enet_host_connect(client, &serverAddress, NETWORK_CLIENT_CHANNELS);
-    if(server==NULL)
+    if(server==NULL) {
+      COUT(2) << "ClientConnection: server == NULL" << std::endl;
       // error handling
       return false;
+    }
     // handshake
-    if(enet_host_service(client, &event, NETWORK_CLIENT_TIMEOUT)>0 && event.type == ENET_EVENT_TYPE_CONNECT){
+    if(enet_host_service(client, &event, NETWORK_CLIENT_TIMEOUT)>=0 && event.type == ENET_EVENT_TYPE_CONNECT){
       established=true;
       return true;
     }
-    else
-      return false;
+    else {
+      COUT(2) << "ClientConnection: enet_host_service < 0 or event.type != ENET_EVENT_TYPE_CONNECT # EVENT:" << event.type << std::endl;
+      return false;
+    }
   }
 
Index: /code/branches/network/src/network/ClientConnection.h
===================================================================
--- /code/branches/network/src/network/ClientConnection.h	(revision 1376)
+++ /code/branches/network/src/network/ClientConnection.h	(revision 1377)
@@ -54,6 +54,6 @@
 #define NETWORK_PORT 55556
 #define NETWORK_CLIENT_MAX_CONNECTIONS 5
-#define NETWORK_CLIENT_TIMEOUT 100
-#define NETWORK_SEND_WAIT 5
+#define NETWORK_CLIENT_TIMEOUT 10000
+#define NETWORK_SEND_WAIT 500
 #define NETWORK_CLIENT_CHANNELS 2
 
@@ -75,5 +75,5 @@
     bool sendPackets();
     // send out all queued packets and save result in event
-    bool sendPackets(ENetEvent *event);
+    //bool sendPackets(ENetEvent *event);
     bool waitEstablished(int milisec);
     bool isConnected(){return established;}